package io.reisub.openosrs.motherlodeminer.tasks;

import io.reisub.openosrs.motherlodeminer.MotherlodeMiner;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Position;
import net.runelite.client.plugins.iutils.scene.RectangularArea;

import javax.inject.Inject;

public class Deposit extends Task {
    @Inject
    private MotherlodeMiner plugin;

    private final RectangularArea hopperArea = new RectangularArea(
            new Position(3741, 5657, 0),
            new Position(3755, 5674, 0)
    );

    @Override
    public String getStatus() {
        return "Depositing in hopper";
    }

    @Override
    public boolean validate() {
        return plugin.getCurrentActivity() == Activity.IDLE
                && !plugin.isUpstairs()
                && game.inventory().withName("Pay-dirt").exists();
    }

    @Override
    public void execute() {
        iObject hopper = game.objects().withName("Hopper").nearest();
        if (hopper == null) return;

        plugin.setActivity(Activity.DEPOSITING);

        hopper.interact("Deposit");
        game.waitUntil(() -> plugin.getCurrentActivity() == Activity.IDLE, 15);
        game.tick(2);
    }
}
