package io.reisub.openosrs.motherlodeminer.tasks;

import io.reisub.openosrs.motherlodeminer.MotherlodeMiner;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Position;
import net.runelite.client.plugins.iutils.scene.RectangularArea;

import javax.inject.Inject;

public class GoDown extends Task {
    @Inject
    private MotherlodeMiner plugin;

    private final RectangularArea miningArea = new RectangularArea(
            new Position(3748, 5676, 0),
            new Position(3754, 5684, 0)
    );

    @Override
    public String getStatus() {
        return "Going down";
    }

    @Override
    public boolean validate() {
        return plugin.getCurrentActivity() == Activity.IDLE
                && plugin.isUpstairs()
                && game.inventory().full();
    }

    @Override
    public void execute() {
        iObject ladder = game.objects().withName("Ladder").nearest();
        if (ladder == null) return;

        ladder.interact("Climb");
        game.waitUntil(() -> !plugin.isUpstairs(), 15);
        game.tick();
    }
}
