package io.reisub.openosrs.motherlodeminer.tasks;

import io.reisub.openosrs.motherlodeminer.MotherlodeMiner;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.util.tasks.BankTask;
import net.runelite.api.ItemID;

import javax.inject.Inject;
import java.time.Duration;
import java.time.Instant;

public class HandleBank extends BankTask {
    @Inject
    private MotherlodeMiner plugin;

    @Override
    public boolean validate() {
        if (plugin.isUpstairs() || plugin.getCurrentActivity() != Activity.IDLE) return false;

        return isLastBankDurationAgo(Duration.ofSeconds(2))
                && game.inventory().withId(
                ItemID.RUNITE_ORE,
                ItemID.ADAMANTITE_ORE,
                ItemID.MITHRIL_ORE,
                ItemID.GOLD_ORE,
                ItemID.COAL,
                ItemID.UNCUT_SAPPHIRE,
                ItemID.UNCUT_EMERALD,
                ItemID.UNCUT_RUBY,
                ItemID.UNCUT_DIAMOND,
                ItemID.UNCUT_DRAGONSTONE
        ).exists();
    }

    @Override
    public void execute() {
        openBank();

        bank.depositExcept(false, ItemID.HAMMER, ItemID.GOLDEN_NUGGET);
        bank.close();
        game.waitUntil(() -> !bank.isOpen(), 3);

        last = Instant.now();
    }
}
