package io.reisub.openosrs.motherlodeminer.tasks;

import io.reisub.openosrs.motherlodeminer.MotherlodeMiner;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Position;
import net.runelite.client.plugins.iutils.scene.RectangularArea;

import javax.inject.Inject;

public class Mine extends Task {
    @Inject
    private MotherlodeMiner plugin;

    private final RectangularArea miningArea = new RectangularArea(
            new Position(3748, 5676, 0),
            new Position(3754, 5684, 0)
    );

    private iObject oreVein;

    @Override
    public String getStatus() {
        return "Mining";
    }

    @Override
    public boolean validate() {
        if (plugin.getCurrentActivity() != Activity.IDLE) return false;

        if (!plugin.isUpstairs()) return false;

        oreVein = game.objects()
                .withName("Ore vein")
                .withAction("Mine")
                .filter((obj) -> miningArea.contains(obj.position()) && !obj.position().equals(new Position(3764, 5665, 0))).nearest();

        return plugin.getCurrentActivity() == Activity.IDLE
                && !game.inventory().full()
                && oreVein != null;
    }

    @Override
    public void execute() {
        plugin.setCurrentVeinPosition(oreVein.position());

        oreVein.interact("Mine");
        game.waitUntil(() -> plugin.getCurrentActivity() == Activity.MINING, 15);

    }
}
