package io.reisub.openosrs.motherlodeminer.tasks;

import io.reisub.openosrs.motherlodeminer.MotherlodeMiner;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.iObject;

import javax.inject.Inject;

public class WithdrawSack extends Task {
    @Inject
    private MotherlodeMiner plugin;

    @Override
    public String getStatus() {
        return "Withdrawing from sack";
    }

    @Override
    public boolean validate() {
        return !plugin.isUpstairs()
                && plugin.getCurrentActivity() == Activity.IDLE
                && plugin.isSackFull()
                && !game.inventory().withId(
                ItemID.RUNITE_ORE,
                ItemID.ADAMANTITE_ORE,
                ItemID.MITHRIL_ORE,
                ItemID.GOLD_ORE,
                ItemID.COAL,
                ItemID.UNCUT_SAPPHIRE,
                ItemID.UNCUT_EMERALD,
                ItemID.UNCUT_RUBY,
                ItemID.UNCUT_DIAMOND,
                ItemID.UNCUT_DRAGONSTONE
        ).exists();
    }

    @Override
    public void execute() {
        iObject sack = game.objects().withName("Sack").withAction("Search").nearest();
        if (sack == null) return;

        plugin.setActivity(Activity.WITHDRAWING);

        sack.interact("Search");

        game.waitUntil(() -> plugin.getCurrentActivity() == Activity.IDLE, 30);
    }
}
