package io.reisub.openosrs.util.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.game.iNPC;
import net.runelite.client.plugins.iutils.game.iObject;

import java.time.Duration;
import java.time.Instant;

public abstract class BankTask extends Task {
    protected Instant last = Instant.EPOCH;

    @Override
    public String getStatus() {
        return "Banking";
    }

    protected void openBank() {
        openBank(15);
    }

    protected boolean openBank(int waitTicks) {
        if (!bank.isOpen()) {
            iObject bankObj = getBankObject();

            if (bankObj != null) {
                if (bankObj.actions().contains("Bank")) {
                    bankObj.interact("Bank");
                } else if (bankObj.actions().contains("Use")) {
                    bankObj.interact("Use");
                } else {
                    bankObj.interact(0);
                }
            } else {
                iNPC bankNpc = getBankNpc();
                if (bankNpc == null) return false;

                if (bankNpc.actions().contains("Bank")) {
                    bankNpc.interact("Bank");
                } else {
                    bankNpc.interact(0);
                }
            }

            game.waitUntil(() -> bank.isOpen(), waitTicks);
        }

        return bank.isOpen();
    }

    protected boolean isLastBankDurationAgo(Duration duration) {
        return Duration.between(last, Instant.now()).compareTo(duration) >= 0;
    }

    protected iObject getBankObject() {
        return game.objects()
                .withName("Bank chest", "Bank booth", "Bank Chest-wreck", "Bank chest")
                .nearest();
    }

    protected iNPC getBankNpc() {
        return game.npcs()
                .withAction("Bank")
                .nearest();
    }
}
